﻿using System;
using System.Collections.Generic;
using System.Text;
using AdiIRCAPI; // Include the API

namespace StripSystem
{
    public class StripSystem : IPlugin // Reference this is a plugin
    {
        private string myName = "StripSystem";
        private string myDescription = "Strip out system notices";
        private string myAuthor = "Per Amundsen";
        private string myVersion = "1.0.0";
        private string myEmail = "amundsen@gmail.com"; // optional

        IPluginHost myHost = null;
        ITools myTools = null;

        public string Description
        {
            get { return myDescription; }
        }

        public string Author
        {
            get { return myAuthor; }
        }

        public string Name
        {
            get { return myName; }
        }

        public string Version
        {
            get { return myVersion; }
        }

        public string Email
        {
            get { return myEmail; }
        }

        public IPluginHost Host
        {
            get { return myHost; }
            set { myHost = value; }
        }

        public ITools Tools
        {
            get { return myTools; }
            set { myTools = value; }
        }

        public StripSystem()
        {

        }

        public void Initialize()
        {
            // This is called when the plugin is loaded
            // Suscribe to delegates here
            myHost.OnJoin += new Join(myHost_OnJoin);
            myHost.OnPart += new Part(myHost_OnPart);
            myHost.OnQuit += new Quit(myHost_OnQuit);
        }

        void myHost_OnQuit(IServer Server, IUser User, string Data, out EatData Return)
        {
            Return = EatData.EatText;
        }

        void myHost_OnPart(IServer Server, IChannel Channel, IUser User, string PartMessage, out EatData Return)
        {
            Return = EatData.EatText;
        }

        void myHost_OnJoin(IServer Server, IChannel Channel, IUser User, out EatData Return)
        {
            Return = EatData.EatText;
        }

        public void Dispose()
        {
            // This is called when the plugin is unloaded
        }
    }
}